//时有疫，西人谓之曰可畏（COVID真乃畏惧耶）。大有一人得病，邻里升天之势。驻足于室可避祸，唯饮食堪忧。口罩不足，全民惧病，亦惧饥。倘口罩可自洁，无异于新，则无惧封城锁国以可安然哉。
//勿以酒类消洗口罩，恐毁之。仅可以热风熏之。水洗可矣，叹之后无能阻挡可畏。有一法可使水洗口罩亦可拒可畏于口鼻之外。

#include <DHT.h>
#include <U8g2lib.h>
#include <Wire.h>

boolean Func[]={0, 0, 0, 0};

boolean Func_Lock[]={0, 0, 0, 0};

volatile unsigned long Heat_Timer; //中武火锻之，怯病驱邪
volatile boolean Heat_Timer_Lock;
volatile unsigned long Recharge_Timer; //最后施法，亦需计时
volatile boolean Recharge_Timer_Lock;
String Status[]={"Hot Wind Off", "Hot Wind On", "UVC Off", "UVC On", "Washer Off", "Washer On", "Recharger Off", "Recharger On"};

U8G2_SSD1306_128X64_NONAME_1_HW_I2C u8g2(U8G2_R0,U8X8_PIN_NONE); //面板示之何术正施为
DHT dht11(11, 11); //监炉童子何在

void Display() {
  u8g2.setFont(u8g2_font_timR08_tf);
  u8g2.setFontPosTop();
  u8g2.setCursor(0,0);
  u8g2.print("Mask Reborn Box  by M.A.P.");
  u8g2.setFont(u8g2_font_timR10_tf);
  u8g2.setFontPosTop();
  u8g2.setCursor(0,15);
  u8g2.print(Status[Func[0]]);
  u8g2.setCursor(0,27);
  u8g2.print(Status[2 + Func[1]]);
  u8g2.setCursor(0,39);
  u8g2.print(Status[4 + Func[2]]);
  u8g2.setCursor(0,51);
  u8g2.print(Status[6 + Func[3]]);
  u8g2.setCursor(90,15);
  u8g2.print(dht11.readTemperature());
  u8g2.setCursor(112,15);
  u8g2.print(" C");
  if (Heat_Timer_Lock == true) {
    u8g2.setCursor(80,27);
    u8g2.print(String(((1800000 - (millis() - Heat_Timer)) / 1000)) + String(" S"));
  } else {
    u8g2.setCursor(80,27);
    u8g2.print("                                ");
  }
  if (Recharge_Timer_Lock == true) {
    u8g2.setCursor(90,51);
    u8g2.print(String(((90000 - (millis() - Recharge_Timer)) / 1000)) + String(" S"));
  } else {
    u8g2.setCursor(90,51);
    u8g2.print("                                ");
  }
}

void Dry(boolean OnOff) {
  digitalWrite(2,(OnOff && dht11.readTemperature() <= 70));
  digitalWrite(3,(OnOff || dht11.readTemperature() >= 50)); 
  if ((OnOff == true && dht11.readTemperature() >= 57) && Heat_Timer_Lock == false) {
    Heat_Timer_Lock = true;
    Heat_Timer = millis();
  }
  if (millis() - Heat_Timer >= 1800000 && Heat_Timer_Lock == true) {
    Func_Lock[0] = 0;
    Heat_Timer_Lock = false;
    Heat_Timer = 0;
  }
}

void Recharge(boolean OnOff) {
  if (OnOff == true) {
    if (Recharge_Timer_Lock == false) {
      Recharge_Timer_Lock = true;
      Recharge_Timer = millis();
    }
    digitalWrite(6,(OnOff && (long) ((millis() - Recharge_Timer)) % (long) (15000) <= 10000));
  } else {
    digitalWrite(6,OnOff);
    Recharge_Timer_Lock = false;
    Recharge_Timer = 0;
  }
  if (millis() - Recharge_Timer >= 90000) {
    Recharge_Timer_Lock = false;
    Recharge_Timer = 0;
    Func[3] = 0;
    Func_Lock[3] = 0;
  }
}

void UVC(boolean OnOff) { //紫外
  digitalWrite(4,OnOff);
}

void Wash(boolean OnOff) { //水洗
  digitalWrite(5,OnOff);
}

void setup(){
  Heat_Timer = 0;
  Heat_Timer_Lock = false;
  Recharge_Timer = 0;
  Recharge_Timer_Lock = false;
  u8g2.begin();
  u8g2.enableUTF8Print();
  dht11.begin();
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
}

void loop(){
  u8g2.firstPage();
  do
  {
  Display();
  }
  while (u8g2.nextPage());
  for (int i = 0; i <= 3; i++) { //须臾轮询各司其职者
    if (digitalRead(14 + i) == false) { //无按钮则解锁
      Func_Lock[i] = 0;
    }
    if (digitalRead(14 + i) == true && Func_Lock[(int)(i - 1)] == 0) { //有按且首次则加锁，取反原状态
      Func_Lock[i] = 1;
      Func[i] = !Func[i];
    }
    switch (i) { //各司其职者分属以下状态，按部就班
     case 0:
      Dry(Func[i]);
      break;
     case 1:
      UVC(Func[i]);
      break;
     case 2:
      Wash(Func[i]);
      break;
     case 3:
      Recharge(Func[i]);
      break;
    }
  }
}
